require 'test/unit'
require 'music_meta_fixer'

class MusicMetaFixerTest < Test::Unit::TestCase
  def test_itunes_api
    pretty_printer = MusicMetaFixer::PrettyPrinter.new
    itunes_api = MusicMetaFixer::ItunesAPI.new("Hardwell Apollo")
    puts "\n"
    song_info = itunes_api.get_song_info

    assert_equal "Hardwell", song_info.artist
    assert_equal "Apollo (feat. Amba Shepherd)", song_info.name
    assert_equal "Dance" , song_info.genre
    assert_equal "2012", song_info.year
    assert_equal "Apollo (feat. Amba Shepherd) - Single", song_info.album
    pretty_printer.print_itunes_api_query(itunes_api)
  end

  def test_tag_editor_getting_song_info
    # TODO Export that bacon pancake
    filepath = CGI.unescape ENV['bacon_pancakes']
    song_info = MusicMetaFixer::TagEditor.get_song_info(filepath)

    assert_equal "Airbase", song_info.artist
    assert_equal "Ocean Realm", song_info.name
    assert_equal "Dance" , song_info.genre
    assert_equal 2004, song_info.year
    assert_equal "Pandemonium / Ocean Realm - Single", song_info.album
  end

  def test_music_comparer
    song = MusicMetaFixer::Song.new "Every Teardrop"
    song.artist =  "Swedish House Mafia"
    song.genre = "Dance"

    song_copy = song.clone
    song_copy.artist = "Coldplay"
    song_copy.genre = "Pop"

    assert_equal [:artist, :genre], song.compare_to(song_copy)
  end

end
